#include <stdio.h>
#include <algorithm>
#include <vector>
using namespace std;

int poisoned[1<<14];
int poisonedarround[1<<14];
int N, maxlvl = -1;
int path[1<<14], bestpath[1<<14];

struct A
{
       int poisonedarround, neighbour;
       A(int _a, int _b):poisonedarround(_a), neighbour(_b){}
       A(){}
       bool operator<(A a) const
       {
            if (poisonedarround != a.poisonedarround) 
             return poisonedarround < a.poisonedarround;
            return neighbour < a.neighbour;
       }
       
};
int T;
void printbest()
{
     printf("%d\n", maxlvl+1);
     for (int i = 0; i <= maxlvl; i++)
     {
         printf("%d", (int)((bool)(bestpath[i]&(1<<0))));
          for (int m = 1; m < N; m++) printf(" %d", (int)((bool)(bestpath[i]&(1<<m))));
         printf("\n");
     }
}
void pfs(int k, int lvl)
{
     if (clock()-T>4000) 
     {
          printbest();
          exit(0);
     }
     
     path[lvl] = k;
     poisoned[k]++;
     for (int i = 0; i < N; i++) poisoned[k^(1<<i)]++;
     
     if (lvl > maxlvl)
     {
             maxlvl = lvl;
             memcpy(bestpath, path, sizeof(int)*(lvl+1));
     }
     vector<A> v;
     for (int i = 0; i < N; i++) if (poisoned[ k^(1<<i) ] == 1)
       v.push_back(A(poisoned[k^(1<<i)], k^(1<<i)));
     sort(v.begin(), v.end());
     
     for (int i = 0; i < v.size(); i++)
     {
         int next = v[i].neighbour;
         poisoned[next]--;
         pfs(next, lvl+1);
         poisoned[next]++;
     }     
     for (int i = 0; i < N; i++) poisoned[k^(1<<i)]--;
     poisoned[k]--;
}

int main()
{
    scanf("%d", &N);
    T = clock();
    pfs(0, 0);
    printbest();
    return 0;
}
