#include <iostream>
#include <cmath>
using namespace std;

#define eps 1e-14

struct solar
{
    double speed;
    double ang;
       int o;
    void read()
    {
        double x, y;
        scanf("%lf%lf%lf%d", &x, &y, &speed, &o);
        ang = atan2(y, x);
        
        if(ang < eps) ang += 2.0*M_PI; 
        double dist = sqrt(x*x + y*y);
        speed = (speed*sqrt(2))/dist;
    }
};



double start , delta;

void solve1(solar p1, solar p2)
{
    
    double ang ;
    
    if (p1.o > 0)
    ang = p2.ang - p1.ang;
        else
    ang = p1.ang - p2.ang;
    
    if (ang < eps) ang += 2.0 * M_PI;
   // printf("%lf\n", ang*180.0/M_PI);
    double f, l;
    
    f = 0.0; l = 10000;
    double mid;
    int i;
    for (i = 0;i<1000;i++)
    {
        mid = f + (l-f)/2.0;
        
        if(p1.speed*mid - p2.speed*mid - ang < eps) f = mid;
        else
        l = mid;
    } 
    
    start = l;
    
    f = 0.0; l = 10000.0;
    
    for (i = 0;i<1000;i++)
    {
        mid = f + (l-f)/2.0;
        
        if(p1.speed*mid - 2.0*M_PI - p2.speed*mid < eps) f = mid;
        else
        l = mid;
    } 
    delta = f;
}
void solve2(solar p1, solar p2)
{
    //double ang = 2.0*M_PI - (p2.ang - p1.ang);    
    
    //if (p2.ang < p1.ang) p2.ang += 2.0*M_PI;
    
   double ang =  p1.ang - p2.ang;
    if (ang < 0.0) ang += 2.0*M_PI;
    
       double f, l;
    
    f = 0.0; l = 10000;
    double mid;
    int i;
    for (i = 0;i<1000;i++)
    {
        mid = f + (l-f)/2.0;
        
        if(2.0*M_PI - ang - p1.speed*mid - p2.speed*mid > - (eps)) f = mid;
        else
        l = mid;
    } 
    
    start = l;
    
    f = 0.0; l = 10000.0;
    
    for (i = 0;i<1000;i++)
    {
        mid = f + (l-f)/2.0;
        
        if(2.0*M_PI - p1.speed*mid - p2.speed*mid > - (eps)) f = mid;
        else
        l = mid;
    } 
    delta = f;
}
int main ()
{
    
    solar p1, p2;
    p1.read();
    p2.read();
    
    if (p1.o * p2.o > 0 && p1.speed < p2.speed) swap(p1, p2);  
    else
        if (p1.o < 0 && p2.o > 0) swap(p1, p2);

    if (p1.o == p2.o) solve1 (p1, p2);
    else
    solve2(p1, p2);

int k;
    scanf("%d", &k);
    if(fabs(p1.ang - p2.ang)< eps) start = 0.0000;
   
    if(start < eps) k--;
   
   //cout<<k<<endl;
   //printf("%.4lf %.4lf\n", start, delta);
    printf("%d\n", (int)((double) start + (double)k*delta));
    
    return 0;
}
