#include <cstdio>
#include <cmath>
#include <algorithm>

const int MAX_T = 2000;

inline bool eq(double a, double b)
{
	return fabs(a - b) < 1e-9;
}

int x[2], y[2], v[2], d[2];
double r[2], ang[2], angV[2], len[2];

double t[2 * MAX_T + 5];
int top;
int K;

int main()
{
    for(int i = 0; i < 2; i ++)
    {
		scanf("%d %d %d %d", &x[i], &y[i], &v[i], &d[i]);
		v[i] *= - d[i];
		r[i] = sqrt(x[i] * x[i] + y[i] * y[i]);
		len[i] = 2 * M_PI * r[i];
		ang[i] = atan2(y[i], x[i]);
		angV[i] = v[i]/r[i];
	}
	scanf("%d", &K);
	if(eq(angV[0], angV[1]))
	{
		puts(eq(ang[0], ang[1]) ? "moving together" : "do not intersect");
		return 0;
	}
	for(int i = -MAX_T; i < MAX_T; i ++)
	{
		double cur = ang[1] - ang[0] + 2 * i * M_PI;
		cur /= (angV[0] - angV[1]);
		if(cur > -1e-9)	t[top ++] = cur;
	}
	std :: sort(t, t + top);
//	for(int i = 0; i < top; i ++)	printf("occurence: %d time: %lf\n", i, t[i]);
	printf("%d\n", (int)t[K - 1]);
    return 0;
}
